



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>你需要知道的三个 CSS3技巧(转)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">你需要知道的三个 CSS3技巧(转)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-30 11:30:24 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>1. 在CSS中用attr()显示HTML属性值</strong></p>
<p><em>attr()</em>功能早在CSS 2.1标准中就已经出现，但现在才开始普遍流行。它提供了一个巧妙的方法在CSS中使用HTML标签上的属性，在很多情况下都能帮你省去了以往需要Javascript处理的过程。</p>
<p>要想使用这个功能，你需要用到三种元素：一个<em>:before</em> 或 <em>:after</em> CSS伪类样式， <em>.content</em>属性，和一个带有你想使用的HTML属性名称的<em>attr()</em>表达式。例如，想去显示<em>&lt;h3&gt;</em>标题上的<em>data-prefix</em>属性的值，你可以写成这样：</p>
<div>
<pre class="prettyprint linenums">h3:before { content: attr(data-prefix) " ";}<br />
&lt;h3 data-prefix="Custom prefix"&gt;This is a heading&lt;/h3&gt;</pre>
</div>
<p>显然，这个例子并没有展示它有多大用处，只是展示了它的基本用法。让我们来试一个更有用的例子，<em>attr()</em>的一个极好的应用就是当用户打印页面时将页面链接显示出来。为了实现这个，你可以这样写：</p>
<div>
<pre class="prettyprint linenums">@media print {<br />
    a:after { content: "(link to "attr(href)")";  }<br />
}<br />
&lt;a href="http://example.com"&gt;Visit our home page&lt;/a&gt;</pre>
</div>
<p>一旦你知道了这个技巧，你就会吃惊于很多时候它能给你的工作带来的方便！</p>
<p><em><strong>提示：</strong>在新版的CSS3标准中，attr()功能被扩展，可以用在各种CSS标记中。</em></p>
<p><strong>2. 使用counter()在列表中自动添加序号</strong></p>
<p>另外一个在CSS 2.1在就已经支持的功能是<em>counter()</em>，使用它，你能方便的在页面标题，区块和其它各种连续出现的页面内容上添加序号。有了它，你就不必限制于只能使用<em>&lt;ol&gt;</em>来实现这个效果，你可以更灵活的在页面上使用自定义数字序列。</p>
<p>关键就是它真的很简单：在<em>:before</em>伪类里的<em>content</em>属性加入counter()：</p>
<div>
<pre class="prettyprint linenums">body {   counter-reset: heading;    }<br />
h4:before {<br />
    counter-increment: heading;<br />
    content: "Heading #" counter(heading) ".";<br />
 }</pre>
</div>
<p>如果你想知道更多关于这个counter归零和自增方法的知识，请参考关于这个主题的<a href="https://developer.mozilla.org/en-US/docs/CSS/Counters" rel="external nofollow noreferrer">Mozilla<br /> Developer Network</a>页面。里面有个极好的如何使用嵌套counter的例子。</p>
<p><strong>3. 使用calc()做算术</strong></p>
<p>最后，但不是最不重要的，让我们来说说<em>calc()</em>功能。这个函数能让你执行简单的算术计算，例如计算元素的长宽，免去了你写不易维护的Javascript代码。这个函数支持所有简单的基本算术运算，包括加减乘除。</p>
<p>比方说，你想创建一个元素，使它的宽度占满它的父元素，但还要留出一部分像素宽做其它用处：</p>
<div>
<pre class="prettyprint linenums">.parent {<br />
    width: 100%;<br />
    border: solid black 1px;<br />
    position: relative;<br />
}

.child {<br />
    position: absolute;<br />
    left: 100px;<br />
    width: calc(90% - 100px);<br />
    background-color: #ff8;<br />
    text-align: center;<br />
}</pre>
</div>
<p>漂亮吧，不是吗？更详细的介绍请参考<a href="http://www.w3.org/TR/css3-values/#calc" rel="external nofollow noreferrer">W3C CSS calc 规范</a>。</p>
<p><em><strong>提示：</strong></em>IE9支持calc，貌似Chrome还不支持</p>
<p>我们可以越来越清楚的发现，CSS已经成熟到在某些方法可以替代javascript，极大的简化了web开发人员的工作。如果你还不开始利用这些功能，那只能说是在犯傻。</p>
<div>[英文原文：<a href="http://aptiverse.com/blog/css_features/" rel="external nofollow noreferrer">Three CSS features you need to know about</a> ]</div>
<p>转载自：http://www.oschina.net/news/38231/3-css-features-you-should-know</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4qnnw3kq.html">C&plus;&plus;基础&mdash;&mdash;模拟事务 （2）Composite模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/49g4zw79.html">Hihocoder 1079 离散化</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8oe0dp9.html">ios 关于文件操作 获取 文件大小</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vr6z48.html">java 实例之杨辉三角</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zn4x49.html">properties文件的继承&lpar;套用&rpar;关系</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1np2d9.html">iOS开发系列之触摸事件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnm75v8.html">loop&lowbar;login&period;sh</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o62d39.html">黑客瑞士军刀NC使用教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzzome8.html">Java多线程中wait&comma; notify and notifyAll的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk2zez8.html">Two Pointers - leetcode &lbrack;两指针问题&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpmp0j9.html">js中两个感叹号的原理与用法分析（转载记录没找到原帖）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk5d7z8.html">Python CGI编程&lpar;转自易百&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp75o69.html">js获取数组中最大值，最小值</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz54w48.html">vue调用 Highcharts  实现多个数据可视化展示</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wdgdwq.html">HashMap 集合的遍历</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwxydv9.html">15LaTeX学习系列之---LaTeX里插入数学公式</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdj6ge9.html">ADC and DAC Analog Filters for Data Conversion</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j14z0l9.html">RNN的深入理解</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rnnj24q.html">Bootstrap&mdash;&mdash;导航居中</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rn05yrq.html">zk如何实现watch</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/96ooon39.html">CUBRID学习笔记 40  使用net修改数据</a>
			</li>
						<li><a href="https://www.batexi.com/a/90vvmwj8.html">CSS笔记（六）链接</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k11jjj9.html">android测试参考&comma;及CreateProcess failure&comma; error问题解决</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gmmj349.html">杭电HDU1042（有点坑的高精度）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j001xeq.html">VS2012创建MVC3项目提示错误&colon; 此模板尝试加载组件程序集 &OpenCurlyDoubleQuote;NuGet&period;VisualStudio&period;Interop&comma; Version&equals;1&period;0&period;0&period;0&comma; Culture&equals;neutral&comma; PublicKeyToken&equals;b03f5f7f11d50a3a&rdquo;。</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gmmp779.html">iOS - CoreMotion</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvvvd5xq.html">sql for xml 嵌套</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjjmm49.html">netty概念</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mnnl52q.html">maven之详解继承与聚合</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e11oym9.html">Python内置函数filter&comma; map&comma; reduce</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
